# Fork
This is a fork of HtmlSpanner, mostly to be used to display help texts in my Android apps opened from different bundled localized raw html files.

# Android HTML rendering library

HtmlSpanner started as the HTML rendering library for PageTurner, but looking through some questions on StackOverflow I noticed how many people were struggling with the infamous ``Html.fromHtml()`` and getting its results to display properly in TextViews.

HtmlSpanner allows you full control over how tags are rendered and gives you all the data about the location of a tag in the text. This allows proper handling of anchors, tables, numbered lists and unordered lists.

It currently renders:

* ``<pre>`` tags
* ``<i>``, ``<strong>``, ``<cite>``, ``<dfn>`` as italic text
* ``<b>`` and ``<strong>`` as bold text
* ``<blockquote>``
* ``<ul>`` and ``<ol>`` with bullets and numbering
* ``<br>`` and ``<p>`` with optional whitespace limiting
* ``<h1>``..``<h6>``
* ``<tt>``
* ``<big>``, ``<small>``
* ``<sup>`` and ``<sub>``
* ``<center>``
* ``<tables>``
* ``<img>``
* ``<a>``

The default link implementation just opens URLs, but it can be easily overridden to support anchors.

HtmlSpanner uses HtmlCleaner to do most of the heavy lifting for parsing HTML files.

# Add the library to your project

## As jar file
* Compile htmlspanner with ``ant release`` and put resulting classes.jar from bin folder into your projects libs folder
* Also copy htmlcleaner-2.2.jar to your libs folder

## As Android library project
* New -> Android Project -> Create project from existing source, choose htmlspanner 
* Add htmlspanner as Android Lib (Properties of your project -> Android -> Library -> add htmlspanner as android library)
* Copy htmlcleaner-2.2.jar to your libs folder

# Usage
In its simplest form, just call ``(new HtmlSpanner()).fromHtml()`` to get similar output as Android's ``Html.fromHtml()``.

# Android 4.1 TextView Bug
On Android 4.1 TextViews with specific spans lead to a crash. You can use net.nightwhistler.htmlspanner.JellyBeanSpanFixTextView as a workaround, which falls back to plain text only when the bug appears.
This class is from https://gist.github.com/3424004
see http://code.google.com/p/android/issues/detail?id=35466 and http://code.google.com/p/android/issues/detail?id=34872

# HTMLCleaner Source
see http://htmlcleaner.sourceforge.net/index.php

The fork under https://github.com/amplafi/htmlcleaner can not be used on Android <= 2.1 as it uses java.lang.String.isEmpty
